diff --git a/src/backend/access/undo/undodiscard.c b/src/backend/access/undo/undodiscard.c
new file mode 100644
index 0000000..afe5834
--- /dev/null
+++ b/src/backend/access/undo/undodiscard.c
@@ -0,0 +1,447 @@
+/*-------------------------------------------------------------------------
+ *
+ * undodiscard.c
+ *	  discard undo records
+ *
+ * Portions Copyright (c) 1996-2017, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/backend/access/undo/undodiscard.c
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "access/transam.h"
+#include "access/xlog.h"
+#include "access/xact.h"
+#include "access/undolog.h"
+#include "access/undodiscard.h"
+#include "catalog/pg_tablespace.h"
+#include "miscadmin.h"
+#include "storage/block.h"
+#include "storage/buf.h"
+#include "storage/bufmgr.h"
+#include "storage/shmem.h"
+#include "storage/proc.h"
+#include "utils/resowner.h"
+#include "postmaster/undoloop.h"
+
+static UndoRecPtr FetchLatestUndoPtrForXid(UndoRecPtr urecptr,
+										   UnpackedUndoRecord *uur_start,
+										   UndoLogControl *log);
+
+/*
+ * Discard the undo for the log
+ *
+ * Search the undo log, get the start record for each transaction until we get
+ * the transaction with xid >= xmin or an invalid xid.  Then call undolog
+ * routine to discard upto that point and update the memory structure for the
+ * log slot. We set the hibernate flag if we do not have any undo logs, this
+ * flag is passed to the undo worker wherein it determines if system is idle
+ * and it should sleep for sometime.
+ *
+ * Return the oldest xid remaining in this undo log (which should be >= xmin,
+ * since we'll discard everything older).  Return InvalidTransactionId if the
+ * undo log is empty.
+ */
+static TransactionId
+UndoDiscardOneLog(UndoLogControl *log, TransactionId xmin, bool *hibernate)
+{
+	UndoRecPtr	undo_recptr, next_insert, from_urecptr;
+	UndoRecPtr	next_urecptr = InvalidUndoRecPtr;
+	UnpackedUndoRecord	*uur = NULL;
+	bool	need_discard = false;
+	bool	log_complete = false;
+	TransactionId	undoxid = InvalidTransactionId;
+	TransactionId	xid = log->oldest_xid;
+	TransactionId	latest_discardxid = InvalidTransactionId;
+
+	undo_recptr = log->oldest_data;
+
+	/* There might not be any undo log and hibernation might be needed. */
+	*hibernate = true;
+
+	/* Loop until we run out of discardable transactions. */
+	do
+	{
+		bool pending_abort = false;
+
+		next_insert = UndoLogGetNextInsertPtr(log->logno, xid);
+
+		/*
+		 * If the next insert location in the undo log is same as the oldest
+		 * data for the log then there is nothing more to discard in this log
+		 * so discard upto this point.
+		 */
+		if (next_insert == undo_recptr)
+		{
+			/*
+			 * If the discard location and the insert location is same then
+			 * there is nothing to discard.
+			 */
+			if (undo_recptr == log->oldest_data)
+				break;
+			else
+				log_complete = true;
+		}
+		else
+		{
+			/* Fetch the undo record for given undo_recptr. */
+			uur = UndoFetchRecord(undo_recptr, InvalidBlockNumber,
+								  InvalidOffsetNumber, InvalidTransactionId,
+								  NULL, NULL);
+
+			Assert(uur != NULL);
+
+			if (!TransactionIdDidCommit(uur->uur_xid) &&
+				TransactionIdPrecedes(uur->uur_xid, xmin) &&
+				uur->uur_progress == 0)
+			{
+				/*
+				 * At the time of recovery, we might not have a valid next undo
+				 * record pointer and in that case we'll calculate the location
+				 * of from pointer using the last record of next insert
+				 * location.
+				 */
+				if (ConditionTransactionUndoActionLock(uur->uur_xid))
+				{
+					TransactionId xid = uur->uur_xid;
+					UndoLogControl	*log = NULL;
+					UndoLogNumber 	logno;
+
+					logno = UndoRecPtrGetLogNo(undo_recptr);
+					log = UndoLogGet(logno, false);
+
+					/*
+					 * If the corresponding log got rewinded to a location
+					 * prior to undo_recptr, the undo actions are already
+					 * applied.
+					 */
+					if (log->meta.insert > undo_recptr)
+					{
+						UndoRecordRelease(uur);
+
+						/* Fetch the undo record under undo action lock. */
+						uur = UndoFetchRecord(undo_recptr, InvalidBlockNumber,
+											  InvalidOffsetNumber, InvalidTransactionId,
+											  NULL, NULL);
+						/*
+						 * If the undo actions for the aborted transaction is
+						 * already applied then continue discarding the undo log
+						 * otherwise discard till current point and stop processing
+						 * this undo log.
+						 * Also, check this is indeed the transaction id we're
+						 * looking for. It is possible that after rewinding
+						 * some other transaction has inserted an undo record.
+						 */
+						if (uur->uur_xid == xid && uur->uur_progress == 0)
+						{
+							from_urecptr = FetchLatestUndoPtrForXid(undo_recptr, uur, log);
+							(void)PushRollbackReq(from_urecptr, undo_recptr, uur->uur_dbid);
+							pending_abort = true;
+						}
+					}
+
+					TransactionUndoActionLockRelease(xid);
+				}
+				else
+					pending_abort = true;
+			}
+
+			next_urecptr = uur->uur_next;
+			undoxid = uur->uur_xid;
+			xid = undoxid;
+		}
+
+		/* we can discard upto this point. */
+		if (TransactionIdFollowsOrEquals(undoxid, xmin) ||
+			next_urecptr == SpecialUndoRecPtr ||
+			UndoRecPtrGetLogNo(next_urecptr) != log->logno ||
+			log_complete  || pending_abort)
+		{
+			/* Hey, I got some undo log to discard, can not hibernate now. */
+			*hibernate = false;
+
+			if (uur != NULL)
+				UndoRecordRelease(uur);
+
+			/*
+			 * If Transaction id is smaller than the xmin that means this must
+			 * be the last transaction in this undo log, so we need to get the
+			 * last insert point in this undo log and discard till that point.
+			 * Also, if the transaction has pending abort, we stop discarding
+			 * undo from the same location.
+			 */
+			if (TransactionIdPrecedes(undoxid, xmin) && !pending_abort)
+			{
+				UndoRecPtr	next_insert = InvalidUndoRecPtr;
+
+				/*
+				 * Get the last insert location for this transaction Id, if it
+				 * returns invalid pointer that means there is new transaction
+				 * has started for this undolog.  So we need to refetch the undo
+				 * and continue the process.
+				 */
+				next_insert = UndoLogGetNextInsertPtr(log->logno, undoxid);
+				if (!UndoRecPtrIsValid(next_insert))
+					continue;
+
+				undo_recptr = next_insert;
+				need_discard = true;
+				latest_discardxid = undoxid;
+				undoxid = InvalidTransactionId;
+			}
+
+			LWLockAcquire(&log->discard_lock, LW_EXCLUSIVE);
+
+			/*
+			 * If no more pending undo logs then set the oldest transaction to
+			 * InvalidTransactionId.
+			 */
+			if (log_complete)
+				log->oldest_xid = InvalidTransactionId;
+			else
+				log->oldest_xid = undoxid;
+
+			log->oldest_data = undo_recptr;
+			LWLockRelease(&log->discard_lock);
+
+			if (need_discard)
+				UndoLogDiscard(undo_recptr, latest_discardxid);
+
+			break;
+		}
+
+		/*
+		 * This transaction is smaller than the xmin so lets jump to the next
+		 * transaction.
+		 */
+		undo_recptr = next_urecptr;
+		latest_discardxid = undoxid;
+
+		if(uur != NULL)
+		{
+			UndoRecordRelease(uur);
+			uur = NULL;
+		}
+
+		need_discard = true;
+	} while (true);
+
+	return undoxid;
+}
+
+/*
+ * Discard the undo for all the transaction whose xid is smaller than xmin
+ *
+ *	Check the DiscardInfo memory array for each slot (every undo log) , process
+ *	the undo log for all the slot which have xid smaller than xmin or invalid
+ *	xid. Fetch the record from the undo log transaction by transaction until we
+ *	find the xid which is not smaller than xmin.
+ */
+void
+UndoDiscard(TransactionId oldestXmin, bool *hibernate)
+{
+	TransactionId	oldestXidHavingUndo = oldestXmin;
+	UndoLogControl *log = NULL;
+
+	/*
+	 * TODO: Ideally we'd arrange undo logs so that we can efficiently find
+	 * those with oldest_xid < oldestXmin, but for now we'll just scan all of
+	 * them.
+	 */
+	while ((log = UndoLogNext(log)))
+	{
+		TransactionId oldest_xid = InvalidTransactionId;
+
+		/* We can't process temporary undo logs. */
+		if (log->meta.persistence == UNDO_TEMP)
+			continue;
+
+		/*
+		 * If the first xid of the undo log is smaller than the xmin the try
+		 * to discard the undo log.
+		 */
+		if (TransactionIdPrecedes(log->oldest_xid, oldestXmin))
+		{
+			/*
+			 * If the XID in the discard entry is invalid then start scanning
+			 * from the first valid undorecord in the log.
+			 */
+			if (!TransactionIdIsValid(log->oldest_xid))
+			{
+				bool		full = false;
+				UndoRecPtr urp = UndoLogGetFirstValidRecord(log, &full);
+
+				if (!UndoRecPtrIsValid(urp))
+				{
+					/*
+					 * There is nothing to be discarded.  If there is also no
+					 * more free space, then a call to UndoLogDiscard() will
+					 * discard it the undo log completely and free up the
+					 * UndoLogControl slot.
+					 */
+					if (full)
+						UndoLogDiscard(MakeUndoRecPtr(log->meta.logno,
+													  log->meta.discard),
+									   InvalidTransactionId);
+					continue;
+				}
+
+				LWLockAcquire(&log->discard_lock, LW_SHARED);
+				log->oldest_data = urp;
+				LWLockRelease(&log->discard_lock);
+			}
+
+			/* Process the undo log. */
+			oldest_xid = UndoDiscardOneLog(log, oldestXmin, hibernate);
+		}
+
+		if (TransactionIdIsValid(oldest_xid) &&
+			TransactionIdPrecedes(oldest_xid, oldestXidHavingUndo))
+			oldestXidHavingUndo = oldest_xid;
+	}
+
+	/*
+	 * Update the oldestXidHavingUndo in the shared memory.
+	 *
+	 * XXX In future if multiple worker can perform discard then we may need
+	 * to use compare and swap for updating the shared memory value.
+	 */
+	pg_atomic_write_u32(&ProcGlobal->oldestXidHavingUndo, oldestXidHavingUndo);
+}
+
+/*
+ * Fetch the latest urec pointer for the transaction.
+ */
+UndoRecPtr
+FetchLatestUndoPtrForXid(UndoRecPtr urecptr, UnpackedUndoRecord *uur_start,
+						 UndoLogControl *log)
+{
+	UndoRecPtr next_urecptr, from_urecptr;
+	uint16	prevlen;
+	UndoLogOffset next_insert;
+	UnpackedUndoRecord *uur;
+	bool refetch = false;
+
+	uur = uur_start;
+
+	while (true)
+	{
+		/* fetch the undo record again if required. */
+		if (refetch)
+		{
+			uur = UndoFetchRecord(urecptr, InvalidBlockNumber,
+								  InvalidOffsetNumber, InvalidTransactionId,
+								  NULL, NULL);
+			refetch = false;
+		}
+
+		next_urecptr = uur->uur_next;
+		prevlen = UndoLogGetPrevLen(log->logno);
+
+		/*
+		 * If this is the last transaction in the log then calculate the latest
+		 * urec pointer using next insert location of the undo log.  Otherwise,
+		 * calculate using next transaction's start pointer.
+		 */
+		if (uur->uur_next == SpecialUndoRecPtr)
+		{
+			/*
+			 * While fetching the next insert location if the new transaction
+			 * has already started in this log then lets re-fetch the undo
+			 * record.
+			 */
+			next_insert = UndoLogGetNextInsertPtr(log->logno, uur->uur_xid);
+			if (!UndoRecPtrIsValid(next_insert))
+			{
+				if (uur != uur_start)
+					UndoRecordRelease(uur);
+				refetch = true;
+				continue;
+			}
+
+			from_urecptr = UndoGetPrevUndoRecptr(next_insert, prevlen,
+												 InvalidUndoRecPtr);
+			break;
+		}
+		else if ((UndoRecPtrGetLogNo(next_urecptr) != log->logno) &&
+				UndoLogIsDiscarded(next_urecptr))
+		{
+			/*
+			 * If next_urecptr is in different undolog and its already discarded
+			 * that means the undo actions for this transaction which are in the
+			 * next log has already been executed and we only need to execute
+			 * which are remaining in this log.
+			 */
+			next_insert = UndoLogGetNextInsertPtr(log->logno, uur->uur_xid);
+
+			Assert(UndoRecPtrIsValid(next_insert));
+			from_urecptr = UndoGetPrevUndoRecptr(next_insert, prevlen,
+												 InvalidUndoRecPtr);
+			break;
+		}
+		else
+		{
+			UnpackedUndoRecord	*next_uur;
+
+			next_uur = UndoFetchRecord(next_urecptr,
+										InvalidBlockNumber,
+										InvalidOffsetNumber,
+										InvalidTransactionId,
+										NULL, NULL);
+			/*
+			 * If the next_urecptr is in the same log then calculate the
+			 * from pointer using prevlen.
+			 */
+			if (UndoRecPtrGetLogNo(next_urecptr) == log->logno)
+			{
+				from_urecptr =
+					UndoGetPrevUndoRecptr(next_urecptr, next_uur->uur_prevlen,
+										  InvalidUndoRecPtr);
+				UndoRecordRelease(next_uur);
+				break;
+			}
+			else
+			{
+				/*
+				 * The transaction is overflowed to the next log, so restart
+				 * the processing from then next log.
+				 */
+				log = UndoLogGet(UndoRecPtrGetLogNo(next_urecptr), false);
+				if (uur != uur_start)
+					UndoRecordRelease(uur);
+				uur = next_uur;
+				continue;
+			}
+
+			UndoRecordRelease(next_uur);
+		}
+	}
+
+	if (uur != uur_start)
+		UndoRecordRelease(uur);
+
+	return from_urecptr;
+}
+
+/*
+ * Discard the undo logs for temp tables.
+ */
+void
+TempUndoDiscard(UndoLogNumber logno)
+{
+	UndoLogControl *log = UndoLogGet(logno, false);
+
+	/*
+	 * Discard the undo log for temp table only. Ensure that there is
+	 * something to be discarded there.
+	 */
+	Assert (log->meta.persistence == UNDO_TEMP);
+
+	/* Process the undo log. */
+	UndoLogDiscard(MakeUndoRecPtr(log->logno, log->meta.insert),
+				   InvalidTransactionId);
+}
diff --git a/src/backend/access/undo/undoinsert.c b/src/backend/access/undo/undoinsert.c
index 9ffa46c..4e0fe13 100644
--- a/src/backend/access/undo/undoinsert.c
+++ b/src/backend/access/undo/undoinsert.c
@@ -171,7 +171,6 @@ static UnpackedUndoRecord *UndoGetOneRecord(UnpackedUndoRecord *urec,
 				 UndoPersistence persistence);
 static void UndoRecordPrepareTransInfo(UndoRecPtr urecptr,
 						   UndoRecPtr xact_urp);
-static void UndoRecordUpdateTransInfo(int idx);
 static int UndoGetBufferSlot(RelFileNode rnode, BlockNumber blk,
 				  ReadBufferMode rbm,
 				  UndoPersistence persistence);
@@ -302,12 +301,61 @@ UndoRecordPrepareTransInfo(UndoRecPtr urecptr, UndoRecPtr xact_urp)
 }
 
 /*
+ * Update the progress of the undo record in the transaction header.
+ */
+void
+PrepareUpdateUndoActionProgress(UndoRecPtr urecptr, int progress)
+{
+	Buffer		buffer = InvalidBuffer;
+	BlockNumber	cur_blk;
+	RelFileNode	rnode;
+	UndoLogNumber logno = UndoRecPtrGetLogNo(urecptr);
+	UndoLogControl *log;
+	Page		page;
+	int			already_decoded = 0;
+	int			starting_byte;
+	int			bufidx;
+	int			index = 0;
+
+	log = UndoLogGet(logno, false);
+
+	if (log->meta.persistence == UNDO_TEMP)
+		return;
+
+	UndoRecPtrAssignRelFileNode(rnode, urecptr);
+	cur_blk = UndoRecPtrGetBlockNum(urecptr);
+	starting_byte = UndoRecPtrGetPageOffset(urecptr);
+
+	while (true)
+	{
+		bufidx = UndoGetBufferSlot(rnode, cur_blk,
+								   RBM_NORMAL,
+								   log->meta.persistence);
+
+		xact_urec_info[xact_urec_info_idx].idx_undo_buffers[index++] = bufidx;
+		buffer = undo_buffer[bufidx].buf;
+		page = BufferGetPage(buffer);
+
+		if (UnpackUndoRecord(&xact_urec_info[xact_urec_info_idx].uur, page, starting_byte,
+							 &already_decoded, true))
+			break;
+
+		starting_byte = UndoLogBlockHeaderSize;
+		cur_blk++;
+	}
+
+	xact_urec_info[xact_urec_info_idx].urecptr = urecptr;
+	xact_urec_info[xact_urec_info_idx].uur.uur_progress = progress;
+	xact_urec_info_idx++;
+}
+
+/*
  * Overwrite the first undo record of the previous transaction to update its
  * next pointer.  This will just insert the already prepared record by
  * UndoRecordPrepareTransInfo.  This must be called under the critical section.
  * This will just overwrite the undo header not the data.
  */
-static void
+void
 UndoRecordUpdateTransInfo(int idx)
 {
 	UndoLogNumber logno = UndoRecPtrGetLogNo(xact_urec_info[idx].urecptr);
diff --git a/src/backend/access/undo/undorecord.c b/src/backend/access/undo/undorecord.c
index 23ed374..9af8e45 100644
--- a/src/backend/access/undo/undorecord.c
+++ b/src/backend/access/undo/undorecord.c
@@ -98,6 +98,7 @@ InsertUndoRecord(UnpackedUndoRecord *uur, Page page,
 	 */
 	if (*already_written == 0)
 	{
+		work_hdr.urec_rmid = uur->uur_rmid;
 		work_hdr.urec_type = uur->uur_type;
 		work_hdr.urec_info = uur->uur_info;
 		work_hdr.urec_prevlen = uur->uur_prevlen;
@@ -122,6 +123,7 @@ InsertUndoRecord(UnpackedUndoRecord *uur, Page page,
 		 * We should have been passed the same record descriptor as before, or
 		 * caller has messed up.
 		 */
+		Assert(work_hdr.urec_rmid == uur->uur_rmid);
 		Assert(work_hdr.urec_type == uur->uur_type);
 		Assert(work_hdr.urec_info == uur->uur_info);
 		Assert(work_hdr.urec_prevlen == uur->uur_prevlen);
@@ -285,6 +287,7 @@ UnpackUndoRecord(UnpackedUndoRecord *uur, Page page, int starting_byte,
 					   &my_bytes_decoded, already_decoded, false))
 		return false;
 
+	uur->uur_rmid = work_hdr.urec_rmid;
 	uur->uur_type = work_hdr.urec_type;
 	uur->uur_info = work_hdr.urec_info;
 	uur->uur_prevlen = work_hdr.urec_prevlen;
diff --git a/src/backend/commands/vacuum.c b/src/backend/commands/vacuum.c
index ff1e178..e7a0bbe 100644
--- a/src/backend/commands/vacuum.c
+++ b/src/backend/commands/vacuum.c
@@ -1381,6 +1381,7 @@ vac_truncate_clog(TransactionId frozenXID,
 				  MultiXactId lastSaneMinMulti)
 {
 	TransactionId nextXID = ReadNewTransactionId();
+	TransactionId oldestXidHavingUndo;
 	Relation	relation;
 	HeapScanDesc scan;
 	HeapTuple	tuple;
@@ -1475,6 +1476,15 @@ vac_truncate_clog(TransactionId frozenXID,
 		return;
 
 	/*
+	 * We can't truncate the clog for transactions that still have undo.  The
+	 * oldestXidHavingUndo will be only valid for zheap storage engine, so it
+	 * won't impact any other storage engine.
+	 */
+	oldestXidHavingUndo = pg_atomic_read_u32(&ProcGlobal->oldestXidHavingUndo);
+	if (TransactionIdIsValid(oldestXidHavingUndo))
+		frozenXID = Min(frozenXID, oldestXidHavingUndo);
+
+	/*
 	 * Advance the oldest value for commit timestamps before truncating, so
 	 * that if a user requests a timestamp for a transaction we're truncating
 	 * away right after this point, they get NULL instead of an ugly "file not
diff --git a/src/backend/postmaster/Makefile b/src/backend/postmaster/Makefile
index 71c2321..9ce6ff0 100644
--- a/src/backend/postmaster/Makefile
+++ b/src/backend/postmaster/Makefile
@@ -12,7 +12,7 @@ subdir = src/backend/postmaster
 top_builddir = ../../..
 include $(top_builddir)/src/Makefile.global
 
-OBJS = autovacuum.o bgworker.o bgwriter.o checkpointer.o fork_process.o \
-	pgarch.o pgstat.o postmaster.o startup.o syslogger.o walwriter.o
+OBJS = autovacuum.o bgworker.o bgwriter.o checkpointer.o discardworker.o fork_process.o \
+	pgarch.o pgstat.o postmaster.o startup.o syslogger.o undoworker.o walwriter.o
 
 include $(top_srcdir)/src/backend/common.mk
diff --git a/src/backend/postmaster/bgworker.c b/src/backend/postmaster/bgworker.c
index f5db5a8..772b865 100644
--- a/src/backend/postmaster/bgworker.c
+++ b/src/backend/postmaster/bgworker.c
@@ -20,7 +20,9 @@
 #include "pgstat.h"
 #include "port/atomics.h"
 #include "postmaster/bgworker_internals.h"
+#include "postmaster/discardworker.h"
 #include "postmaster/postmaster.h"
+#include "postmaster/undoworker.h"
 #include "replication/logicallauncher.h"
 #include "replication/logicalworker.h"
 #include "storage/dsm.h"
@@ -129,6 +131,15 @@ static const struct
 	},
 	{
 		"ApplyWorkerMain", ApplyWorkerMain
+	},
+	{
+		"UndoLauncherMain", UndoLauncherMain
+	},
+	{
+		"UndoWorkerMain", UndoWorkerMain
+	},
+	{
+		"DiscardWorkerMain", DiscardWorkerMain
 	}
 };
 
diff --git a/src/backend/postmaster/discardworker.c b/src/backend/postmaster/discardworker.c
new file mode 100644
index 0000000..7cbe6c4
--- /dev/null
+++ b/src/backend/postmaster/discardworker.c
@@ -0,0 +1,170 @@
+/*-------------------------------------------------------------------------
+ *
+ * discardworker.c
+ *	  The undo discard worker for asynchronous undo management.
+ *
+ * Portions Copyright (c) 1996-2017, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * IDENTIFICATION
+ *	  src/backend/postmaster/discardworker.c
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+#include <unistd.h>
+
+/* These are always necessary for a bgworker. */
+#include "access/transam.h"
+#include "miscadmin.h"
+#include "postmaster/bgworker.h"
+#include "storage/ipc.h"
+#include "storage/latch.h"
+#include "storage/lwlock.h"
+#include "storage/proc.h"
+#include "storage/shmem.h"
+
+#include "access/undodiscard.h"
+#include "pgstat.h"
+#include "postmaster/discardworker.h"
+#include "storage/procarray.h"
+#include "tcop/tcopprot.h"
+#include "utils/guc.h"
+#include "utils/resowner.h"
+
+static void undoworker_sigterm_handler(SIGNAL_ARGS);
+
+/* max sleep time between cycles (100 milliseconds) */
+#define MIN_NAPTIME_PER_CYCLE 100L
+#define DELAYED_NAPTIME 10 * MIN_NAPTIME_PER_CYCLE
+#define MAX_NAPTIME_PER_CYCLE 100 * MIN_NAPTIME_PER_CYCLE
+
+static bool got_SIGTERM = false;
+static bool hibernate = false;
+static	long		wait_time = MIN_NAPTIME_PER_CYCLE;
+
+/* SIGTERM: set flag to exit at next convenient time */
+static void
+undoworker_sigterm_handler(SIGNAL_ARGS)
+{
+	got_SIGTERM = true;
+
+	/* Waken anything waiting on the process latch */
+	SetLatch(MyLatch);
+}
+
+/*
+ * DiscardWorkerRegister -- Register a undo discard worker.
+ */
+void
+DiscardWorkerRegister(void)
+{
+	BackgroundWorker bgw;
+
+	/* TODO: This should be configurable. */
+
+	memset(&bgw, 0, sizeof(bgw));
+	bgw.bgw_flags = BGWORKER_SHMEM_ACCESS |
+		BGWORKER_BACKEND_DATABASE_CONNECTION;
+	bgw.bgw_start_time = BgWorkerStart_RecoveryFinished;
+	snprintf(bgw.bgw_name, BGW_MAXLEN, "discard worker");
+	sprintf(bgw.bgw_library_name, "postgres");
+	sprintf(bgw.bgw_function_name, "DiscardWorkerMain");
+	bgw.bgw_restart_time = 5;
+	bgw.bgw_notify_pid = 0;
+	bgw.bgw_main_arg = (Datum) 0;
+
+	RegisterBackgroundWorker(&bgw);
+}
+
+/*
+ * DiscardWorkerMain -- Main loop for the undo discard worker.
+ */
+void
+DiscardWorkerMain(Datum main_arg)
+{
+	ereport(LOG,
+			(errmsg("discard worker started")));
+
+	/* Establish signal handlers. */
+	pqsignal(SIGTERM, undoworker_sigterm_handler);
+	BackgroundWorkerUnblockSignals();
+
+	/* Make it easy to identify our processes. */
+	SetConfigOption("application_name", MyBgworkerEntry->bgw_name,
+					PGC_USERSET, PGC_S_SESSION);
+
+	/*
+	 * Create resource owner for discard worker as it need to read the undo
+	 * records  outside the transaction blocks which intern access buffer read
+	 * routine.
+	 */
+	CreateAuxProcessResourceOwner();
+
+	/* Enter main loop */
+	while (!got_SIGTERM)
+	{
+		int			rc;
+		TransactionId OldestXmin, oldestXidHavingUndo;
+
+		OldestXmin = GetOldestXmin(NULL, PROCARRAY_FLAGS_DEFAULT);
+
+		oldestXidHavingUndo =
+					pg_atomic_read_u32(&ProcGlobal->oldestXidHavingUndo);
+
+		/*
+		 * Call the discard routine if there oldestXidHavingUndo is lagging
+		 * behind OldestXmin.
+		 */
+		if (OldestXmin != InvalidTransactionId &&
+			TransactionIdPrecedes(oldestXidHavingUndo, OldestXmin))
+		{
+			UndoDiscard(OldestXmin, &hibernate);
+
+			/*
+			 * If we got some undo logs to discard or discarded something,
+			 * then reset the wait_time as we have got work to do.
+			 * Note that if there are some undologs that cannot be discarded,
+			 * then above condition will remain unsatisified till oldestXmin
+			 * remains unchanged and the wait_time will not reset in that case.
+			 */
+			if (!hibernate)
+				wait_time = MIN_NAPTIME_PER_CYCLE;
+		}
+
+		/* Wait for more work. */
+		rc = WaitLatch(&MyProc->procLatch,
+					   WL_LATCH_SET | WL_TIMEOUT | WL_POSTMASTER_DEATH,
+					   wait_time,
+					   WAIT_EVENT_UNDO_DISCARD_WORKER_MAIN);
+
+		ResetLatch(&MyProc->procLatch);
+
+		/*
+		 * Increase the wait_time based on the length of inactivity. If wait_time
+		 * is within one second, then increment it by 100 ms at a time. Henceforth,
+		 * increment it one second at a time, till it reaches ten seconds. Never
+		 * increase the wait_time more than ten seconds, it will be too much of
+		 * waiting otherwise.
+		 */
+		if (rc & WL_TIMEOUT && hibernate)
+		{
+			wait_time += (wait_time < DELAYED_NAPTIME ?
+							MIN_NAPTIME_PER_CYCLE : DELAYED_NAPTIME);
+			if (wait_time > MAX_NAPTIME_PER_CYCLE)
+				wait_time = MAX_NAPTIME_PER_CYCLE;
+		}
+
+		/* emergency bailout if postmaster has died */
+		if (rc & WL_POSTMASTER_DEATH)
+			proc_exit(1);
+	}
+
+	ReleaseAuxProcessResources(true);
+
+	/* we're done */
+	ereport(LOG,
+			(errmsg("discard worker shutting down")));
+
+	proc_exit(0);
+}
diff --git a/src/backend/postmaster/pgstat.c b/src/backend/postmaster/pgstat.c
index 03591bf..6cae438 100644
--- a/src/backend/postmaster/pgstat.c
+++ b/src/backend/postmaster/pgstat.c
@@ -3506,6 +3506,12 @@ pgstat_get_wait_activity(WaitEventActivity w)
 		case WAIT_EVENT_SYSLOGGER_MAIN:
 			event_name = "SysLoggerMain";
 			break;
+		case WAIT_EVENT_UNDO_DISCARD_WORKER_MAIN:
+			event_name = "UndoDiscardWorkerMain";
+			break;
+		case WAIT_EVENT_UNDO_LAUNCHER_MAIN:
+			event_name = "UndoLauncherMain";
+			break;			
 		case WAIT_EVENT_WAL_RECEIVER_MAIN:
 			event_name = "WalReceiverMain";
 			break;
@@ -3918,7 +3924,6 @@ pgstat_get_wait_io(WaitEventIO w)
 		case WAIT_EVENT_UNDO_FILE_SYNC:
 			event_name = "UndoFileSync";
 			break;
-
 		case WAIT_EVENT_WALSENDER_TIMELINE_HISTORY_READ:
 			event_name = "WALSenderTimelineHistoryRead";
 			break;
diff --git a/src/backend/postmaster/postmaster.c b/src/backend/postmaster/postmaster.c
index a707d4d..c4acd72 100644
--- a/src/backend/postmaster/postmaster.c
+++ b/src/backend/postmaster/postmaster.c
@@ -111,10 +111,12 @@
 #include "port/pg_bswap.h"
 #include "postmaster/autovacuum.h"
 #include "postmaster/bgworker_internals.h"
+#include "postmaster/discardworker.h"
 #include "postmaster/fork_process.h"
 #include "postmaster/pgarch.h"
 #include "postmaster/postmaster.h"
 #include "postmaster/syslogger.h"
+#include "postmaster/undoworker.h"
 #include "replication/logicallauncher.h"
 #include "replication/walsender.h"
 #include "storage/fd.h"
@@ -981,6 +983,11 @@ PostmasterMain(int argc, char *argv[])
 	 */
 	ApplyLauncherRegister();
 
+	UndoLauncherRegister();
+
+	/* Register the Undo Discard worker. */
+	DiscardWorkerRegister();
+
 	/*
 	 * process any libraries that should be preloaded at postmaster start
 	 */
